searchData={"items":[{"type":"module","title":"ElixirAuthMicrosoft","doc":"Minimalist Microsoft OAuth Authentication for Elixir Apps.\nTested, documented and maintained.\nOffers simple access to tokens and basic user profile info.","ref":"ElixirAuthMicrosoft.html"},{"type":"function","title":"ElixirAuthMicrosoft.generate_oauth_url_authorize/1","doc":"`generate_oauth_url_authorize/1` creates an OAuth2 URL with client_id, redirect_uri and scopes (be sure to create the app registration in Azure Portal AD).\nThe redirect_uri will be the URL Microsoft will redirect after successful sign-in.\nThis is the URL that you should be used in a \"Login with Microsoft\"-type button.","ref":"ElixirAuthMicrosoft.html#generate_oauth_url_authorize/1"},{"type":"function","title":"ElixirAuthMicrosoft.generate_oauth_url_authorize/2","doc":"`generate_oauth_url_authorize/2` is the same as `generate_oauth_url_authorize/1` but with a state parameter.\nThis state parameter should be compared with the one that is sent as query param in the redirect URI after the sign-in is successful.","ref":"ElixirAuthMicrosoft.html#generate_oauth_url_authorize/2"},{"type":"function","title":"ElixirAuthMicrosoft.generate_oauth_url_logout/0","doc":"`generate_oauth_url_logout/0` creates a logout URL.\nThis should the URL the person is redirected to when they want to logout.\nTo define the redirect URL (the URL that the user will be redirected to after successful logout from Microsoft ),\nyou need to set the `MICROSOFT_POST_LOGOUT_REDIRECT_URI` env variable\nor `:post_logout_redirect_uri` in the config file.","ref":"ElixirAuthMicrosoft.html#generate_oauth_url_logout/0"},{"type":"function","title":"ElixirAuthMicrosoft.get_token/2","doc":"`get_token/2` fetches the ID token using the authorization code that was previously obtained.\nEnv variables are used to encode information while fetching the ID token from Microsoft, including the registered client ID that was created in Azure Portal AD.","ref":"ElixirAuthMicrosoft.html#get_token/2"},{"type":"function","title":"ElixirAuthMicrosoft.get_user_profile/1","doc":"`get_user_profile/1` fetches the signed-in Microsoft User info according to the token that is passed by calling `get_token/1`.","ref":"ElixirAuthMicrosoft.html#get_user_profile/1"},{"type":"function","title":"ElixirAuthMicrosoft.http/0","doc":"`http/0` injects a TestDouble in test envs.\nWhen testing, it uses a mocked version of HTTPoison with predictible results. When in production, it uses the original version.","ref":"ElixirAuthMicrosoft.html#http/0"},{"type":"function","title":"ElixirAuthMicrosoft.parse_body_response/1","doc":"`parse_body_response/1` parses the response from Microsoft's endpoints.\nThe keys of the decoded map are converted in atoms, for easier access in templates.\n\n##TODO check cases where the parsed code when fetching fails.","ref":"ElixirAuthMicrosoft.html#parse_body_response/1"},{"type":"module","title":"ElixirAuthMicrosoft.HTTPoisonMock","doc":"A HTTPoison Mock that yields predictable results. Meant for testing.","ref":"ElixirAuthMicrosoft.HTTPoisonMock.html"},{"type":"function","title":"ElixirAuthMicrosoft.HTTPoisonMock.get/2","doc":"Mocks the `get/2` function from HTTPoison.\nIt yields a predictable result similar to Microsoft's JSON result when fetching the user info.\nIt raises an error when an invalid token is passed.","ref":"ElixirAuthMicrosoft.HTTPoisonMock.html#get/2"},{"type":"function","title":"ElixirAuthMicrosoft.HTTPoisonMock.post/3","doc":"Mocks the `post/3` function from HTTPoison.\nIt yields a predictable result, with always the same access token.","ref":"ElixirAuthMicrosoft.HTTPoisonMock.html#post/3"}],"content_type":"text/markdown"}